From: Thomas Loimer <thomas.loimer@tuwien.ac.at>
Date: Wed, 29 Aug 2018 00:10:15 +0200
Origin: https://sourceforge.net/p/mcj/fig2dev/ci/d1c54f6
Subject: Fix some memory leaks, harden reading files v1.3
 Free realname, returned by open_picfile, in genemf.c, genps.c,
 readgif.c, readjpg.c. Free the pointer to the array of row pointers
 in read_png(). For some types of reading failurs, read_gif() would
 return "success". Do not free the data returned by readxbm.c. On
 reading format 1.3 files, assign ppi, do not accept splines
 consisting of one single point.

--- a/fig2dev/dev/genemf.c
+++ b/fig2dev/dev/genemf.c
@@ -2420,11 +2420,12 @@ picbox(F_line *l)
     else if (dy < 0 && dx >= 0)
        rotation = 90;
 
-    if ((picf = open_picfile(l->pic->file, &filtype, true,&realname)) == NULL) {
+    picf = open_picfile(l->pic->file, &filtype, true, &realname);
+    free(realname);	/* not used */
+    if (picf == NULL) {
 	fprintf(stderr, "fig2dev: %s: No such picture file\n", l->pic->file);
 	return;
     }
-    free(realname);	/* not used */
     if (fread(buf, (size_t) 16, (size_t) 1, picf) != 1) {
 	fprintf(stderr, "fig2dev: %s: short read\n", l->pic->file);
 	close_picfile(picf, filtype);
@@ -2442,12 +2443,12 @@ picbox(F_line *l)
     if (strncmp(buf, "\211\120\116\107\015\012\032\012", (size_t) 8) == 0) {
 	/* png file */
 	int pllx, plly;
-	if ((picf = open_picfile(l->pic->file, &filtype, true,&realname)) ==
-									NULL) {
+	picf = open_picfile(l->pic->file, &filtype, true, &realname);
+	free(realname);		/* not used */
+	if (picf == NULL) {
 	    perror(l->pic->file);
 	    return;
 	}
-	free(realname);		/* not used */
 	if (read_png(picf, filtype, l->pic, &pllx, &plly) == 0) {
 	    fprintf(stderr, "fig2dev: %s: illegal format\n", l->pic->file);
 	    close_picfile(picf, filtype);
--- a/fig2dev/dev/genps.c
+++ b/fig2dev/dev/genps.c
@@ -1454,6 +1454,7 @@ genps_line(F_line *l)
 								== NULL) {
 			fprintf(stderr, "No such picture file: %s\n",
 				l->pic->file);
+			free(realname);
 			return;
 		}
 
@@ -1740,8 +1741,9 @@ genps_line(F_line *l)
 		} else if (l->pic->subtype == P_EPS) {
 		    int len;
 		    fputs("% EPS file follows:\n", tfp);
-		    if ((picf=open_picfile(l->pic->file, &filtype, true,
-							&realname)) == NULL) {
+		    picf = open_picfile(l->pic->file, &filtype, true,&realname);
+		    free(realname);
+		    if (picf == NULL) {
 #ifdef	HAVE_STRERROR
 			fprintf(stderr,
 				"Unable to open EPS file '%s': error: %s\n",
@@ -1751,7 +1753,6 @@ genps_line(F_line *l)
 				l->pic->file);
 #endif
 			fputs("gr\n", tfp);
-			free(realname);
 			return;
 		    }
 		    /* use read/write() calls in case of binary data! */
@@ -1775,7 +1776,6 @@ genps_line(F_line *l)
 			    write(fileno(tfp),buf,len);
 			}
 		    }
-		    free(realname);
 		    close_picfile(picf,filtype);
 		}
 
--- a/fig2dev/dev/readgif.c
+++ b/fig2dev/dev/readgif.c
@@ -97,6 +97,7 @@ read_gif(char *filename, int filetype, F
 
 	/* open the file */
 	if ((file=open_picfile(filename, &filetype, false,&realname)) == NULL) {
+		free(realname);
 		fprintf(stderr,"No such GIF file: %s\n", filename);
 		return 0;
 	}
@@ -117,11 +118,13 @@ read_gif(char *filename, int filetype, F
 	version[3] = '\0';
 
 	if ((strcmp(version, "87a") != 0) && (strcmp(version, "89a") != 0)) {
+		free(realname);
 		fprintf(stderr,"Unknown GIF version %s\n",version);
 		return 0;
 	}
 
 	if (! ReadOK(file,buf,7)) {
+		free(realname);
 		return 0;		/* failed to read screen descriptor */
 	}
 
@@ -134,6 +137,7 @@ read_gif(char *filename, int filetype, F
 
 	if (BitSet(buf[4], LOCALCOLORMAP)) {	/* Global Colormap */
 		if (!ReadColorMap(file,GifScreen.BitPixel,pic->cmap)) {
+			free(realname);
 			return 0;	/* error reading global colormap */
 		}
 	}
@@ -143,6 +147,7 @@ read_gif(char *filename, int filetype, F
 
 	for (;;) {
 		if (! ReadOK(file,&c,1)) {
+			free(realname);
 			return 0;	/* EOF / read error on image data */
 		}
 
@@ -163,7 +168,8 @@ read_gif(char *filename, int filetype, F
 		}
 
 		if (! ReadOK(file,buf,9)) {
-			return 1;      /* couldn't read left/top/width/height */
+			free(realname);
+			return 0;      /* couldn't read left/top/width/height */
 		}
 
 		useGlobalColormap = ! BitSet(buf[8], LOCALCOLORMAP);
@@ -172,8 +178,9 @@ read_gif(char *filename, int filetype, F
 
 		if (! useGlobalColormap) {
 		    if (!ReadColorMap(file, bitPixel, pic->cmap)) {
+			free(realname);
 			fprintf(stderr, "error reading local GIF colormap\n");
-			return 1;
+			return 0;
 		    }
 		}
 		break;			/* image starts here, header is done */
--- a/fig2dev/dev/readjpg.c
+++ b/fig2dev/dev/readjpg.c
@@ -107,6 +107,7 @@ JPEGtoPS(char *jpegfile, FILE *PSfile) {
 
   /* reopen the file */
   JPEG->fp = open_picfile(jpegfile, &filtype, true, &realname);
+  free(realname);
 
   /* produce EPS header comments */
   fprintf(PSfile, "%%!PS-Adobe-3.0 EPSF-3.0\n");
--- a/fig2dev/dev/readpng.c
+++ b/fig2dev/dev/readpng.c
@@ -178,6 +178,7 @@ read_png(FILE *file, int filetype, F_pic
 	if ((row_pointers[i] = malloc(rowsize)) == NULL) {
 	    for (j=0; j<i; ++j)
 		free(row_pointers[j]);
+	    free(row_pointers);
 	    return 0;
 	}
     }
@@ -186,8 +187,12 @@ read_png(FILE *file, int filetype, F_pic
     png_read_image(png_ptr, row_pointers);
 
     /* allocate the bitmap */
-    if ((pic->bitmap=malloc(rowsize*h))==NULL)
+    if ((pic->bitmap=malloc(rowsize*h))==NULL) {
+	    for (i=0; i<h; ++i)
+		    free(row_pointers[i]);
+	    free(row_pointers);
 	    return 0;
+    }
 
     /* copy it to our bitmap */
     ptr = pic->bitmap;
@@ -212,6 +217,7 @@ read_png(FILE *file, int filetype, F_pic
     png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
     for (i=0; i<h; ++i)
 	free(row_pointers[i]);
+    free(row_pointers);
 
     pic->subtype = P_PNG;
     pic->hw_ratio = (float) pic->bit_size.y / pic->bit_size.x;
--- a/fig2dev/dev/readxbm.c
+++ b/fig2dev/dev/readxbm.c
@@ -1,7 +1,7 @@
 /*
  * Fig2dev: Translate Fig code to various Devices
  * Parts Copyright (c) 1989-2007 by Brian V. Smith
- * Parts Copyright (c) 2015-2017 by Thomas Loimer
+ * Parts Copyright (c) 2015-2018 by Thomas Loimer
  *
  * Any party obtaining a copy of these files is granted, free of charge, a
  * full and unrestricted irrevocable, world-wide, paid up, royalty-free,
@@ -213,7 +213,7 @@ ReadFromBitmapFile (FILE *file,
 	initHexTable();
 
     /* error cleanup and return macro	*/
-#define	RETURN(code) { if (data) free (data);  return code; }
+#define	RETURN(code) do {if (data) free(data);  return code;} while (0)
 
     while (fgets(line, MAX_SIZE, file)) {
 	if (strlen(line) == MAX_SIZE-1) {
@@ -260,9 +260,8 @@ ReadFromBitmapFile (FILE *file,
 	bytes_per_line = (ww+7)/8 + padding;
 
 	size = bytes_per_line * hh;
-	data = (unsigned char *) malloc ((unsigned int) size);
-	if (!data)
-	  RETURN (0);
+	if ((data = malloc((unsigned int) size)) == NULL)
+	  return 0;
 
 	if (version10p) {
 	    unsigned char *ptr;
@@ -288,12 +287,12 @@ ReadFromBitmapFile (FILE *file,
     }					/* end while */
 
     if (data == NULL) {
-	RETURN (0);
+	return 0;
     }
 
     *data_ret = data;
     *width = ww;
     *height = hh;
 
-    RETURN (1);
+    return 1;
 }
--- a/fig2dev/read1_3.c
+++ b/fig2dev/read1_3.c
@@ -92,6 +92,7 @@ read_1_3_objects(FILE *fp, F_compound *o
 		put_msg("Invalid resolution information (%d).", pixperinch);
 		return -1;
 	}
+	ppi = pixperinch;
 	obj->nwcorner.x = pixperinch;
 	obj->nwcorner.y = coord_sys;
 	while (fscanf(fp, "%d", &object) == 1) {
@@ -469,7 +470,7 @@ read_splineobject(FILE *fp)
 		if (fscanf(fp, " %d %d", &x, &y) != 2) {
 			put_msg("incomplete spline object");
 			free_splinestorage(s);
-			return(NULL);
+			return NULL;
 		};
 		if (x == 9999) break;
 		Point_malloc(q);
@@ -479,6 +480,11 @@ read_splineobject(FILE *fp)
 		p->next = q;
 		p = q;
 	}
+	if (s->points->next == NULL) {
+		put_msg("spline with a single point");
+		free_splinestorage(s);
+		return NULL;
+	}
 	return(s);
 }
 
